
/* =========================================================================== *
|
|  Copyright (c) 1994-2008 by Kobus Barnard (author).
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowledged in publications, and relevant papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarantee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef M_MAT_ERROR_INCLUDED
#define M_MAT_ERROR_INCLUDED

#ifdef __cplusplus
extern "C" {
#endif

#include "m/m_gen.h"

int get_rms_row_error
(
    Vector**      result_vpp,
    const Matrix* first_mp,
    const Matrix* second_mp,
    double*       error_ptr
);

int get_rms_relative_row_error
(
    Vector**      result_vpp,
    const Matrix* first_mp,
    const Matrix* second_mp,
    double*       error_ptr
);

int get_rms_col_error
(
    Vector**      result_vpp,
    const Matrix* first_mp,
    const Matrix* second_mp,
    double*       error_ptr
);

int get_rms_relative_col_error
(
    Vector**      result_vpp,
    const Matrix* first_mp,
    const Matrix* second_mp,
    double*       error_ptr
);

#ifdef __cplusplus
}
#endif

#endif

